;
;
; Pyldin-601 emulator version 2.1 for BeOS / Linux / Win9x/NT
; Copyright (c) Sasha Chukov & Yura Kuznetsov, 2000-2001
;
;
	bits	32

	global	dpmi_get_version_
	global	dpmi_get_cpu_type_
	global	dpmi_simulate_real_interrupt_
	global	dpmi_alloc_real_memory_
	global	dpmi_dealloc_real_memory_

dpmi_get_version_
	push	ebx
	push	ecx
	push	edx
	mov	eax, 0x400
	int	0x31
	and	eax, 0xffff
	pop	edx
	pop	ecx
	pop	ebx
	ret

dpmi_get_cpu_type_
	push	ebx
	push	ecx
	push	edx
	mov	eax, 0x400
	int	0x31
	mov	eax, ecx
	and	eax, byte 0xf
	pop	edx
	pop	ecx
	pop	ebx
	ret

dpmi_simulate_real_interrupt_
	push	ebx
	push	ecx
	push	edi
	mov	ebx, eax
	and	ebx, 0x000000ff
	xor	ecx, ecx
	mov	edi, edx
	mov	eax, 0x0300
	int	0x31
	xor	eax, eax
	jnc	.noerr
	dec	eax
.noerr
	pop	edi
	pop	ecx
	pop	ebx
	ret

dpmi_alloc_real_memory_
	push	edx
	push	eax
	and	ebx, 0xffff
	mov	ax, 0x100
	int	0x31
	pop	ebx
	mov	word [ebx], dx
	pop	edx
	mov	word [edx], ax
	xor	eax, eax
	jnc	.okmem
	dec	eax
.okmem
	ret

dpmi_dealloc_real_memory_
	mov	dx, word [eax]
	mov	ax, 0x101
	int	0x31
	xor	eax, eax
	jnc	.okfre
	dec	eax
.okfre
	ret
