/*
 *
 * Pyldin-601 emulator version 2.1 for BeOS / Linux / Win9x/NT
 * Copyright (c) Sasha Chukov & Yura Kuznetsov, 2000-2001
 *
 */

#ifndef __FLOPPY_H__
#define __FLOPPY_H__

#define FLOPPY_A	0
#define FLOPPY_B	1

extern int floppyOn();
extern int floppyOff();
extern int loadDiskImage(char *name, int disk);
extern int unloadDiskImage(char *name, int disk);
extern int readSector(int Disk, int Track, int Sector, int Head, unsigned char *dst);
extern int writeSector(int Disk, int Track, int Sector, int Head, unsigned char *src);
extern int formaTrack(int Disk, int Track, int Head);
extern int init765();

#endif
