/*
 *
 * Pyldin-601 emulator version 2.1 for BeOS / Linux / Win9x/NT
 * Copyright (c) Sasha Chukov & Yura Kuznetsov, 2000-2001
 *
 */

#include <dos.h>
#include <conio.h>

#include "timer.h"

void (__interrupt __far *biosTimerHandler)();
// char timerHandlerInstalled=0;

// int	fTick;
int	tick50;
int	fRef = 0;
int	curBlink = 0;

void __interrupt __far timerHandler()
{
 (*biosTimerHandler)();
 fRef++;
 tick50 = 0x80;
// if (fRef == 4) { fRef = 0; refreshScr(); };
// fTick--;
 curBlink++;

 IRQrequest = 1;

 outp(0x20,0x20);
}

void installTimerHandler(void)
{
 biosTimerHandler=_dos_getvect(0x08);
 _dos_setvect(0x08,timerHandler);
// timerHandlerInstalled=1;
// fTick = 0;
}

void removeTimerHandler(void)
{
// if(timerHandlerInstalled){
_dos_setvect(0x08,biosTimerHandler);
// timerHandlerInstalled=0;
}
